package dev.peerat.parser.java.printer;

import java.lang.reflect.Modifier;

import dev.peerat.parser.java.Variable;
import dev.peerat.parser.java.value.Value;

public class JavaVariablePrinter extends JavaPrinter<Variable>{

	@Override
	public void print(Variable element, Writer writer, String buffer, JavaPrintProvider provider) throws Exception {
		writer.write(buffer+Modifier.toString(element.getModifier())+" ");
		writer.write(element.getType());
		writer.write(" ");
		writer.write(element.getName());
		if(element.getValue() != null){
			writer.write(" = ");
			Value value = element.getValue();
			provider.getPrinter(value).print(value, writer, "", provider);
			writer.write(";");
		}
	}

}
