package dev.peerat.parser.java.value;

import java.util.List;
import java.util.function.Function;

import dev.peerat.parser.java.JavaElement;
import dev.peerat.parser.java.visitor.JavaVisitor;
import dev.peerat.parser.visitor.Visitor;
import dev.peerat.parser.visitor.VisitorBag;

public class ArrayAccessValue extends Value{
	
	private Value base;
	private Value access;
	
	public ArrayAccessValue(Value base, Value access){
		this.base = base;
		this.access = access;
	}
	
	public Value base(){
		return this.base;
	}
	
	public Value getAccessor(){
		return this.access;
	}

	@Override
	public <E extends JavaElement> E find(Function<JavaElement, Boolean> finder) {
		return null;
	}

	@Override
	public <E extends JavaElement> void findAll(Function<JavaElement, Boolean> finder, List<E> list) {
		
	}

	@Override
	public VisitorBag visit(Visitor<JavaElement> visitor) {
		if(visitor.canVisit(getClass())) return visitor.visit(this);
		VisitorBag bag = new VisitorBag();
		return bag;
	}

}
